EXECUTE IMMEDIATE $$

DECLARE
  COUNTER INTEGER DEFAULT 0;
  MAX_USERS INTEGER DEFAULT 40;
  USER_ID VARCHAR DEFAULT 'USER00';
  USER_NAME VARCHAR DEFAULT 'LABCAMP_USER00';
  USER_WAREHOUSE VARCHAR DEFAULT 'LABCAMP_WH_00';

BEGIN
  FOR I IN 1 TO MAX_USERS DO
    COUNTER := COUNTER + 1;
    LET USER_ID := CONCAT('USER', LPAD(TO_VARCHAR(COUNTER), 2, '0'));
    LET USER_NAME := CONCAT('LABCAMP_', USER_ID);
    LET USER_WAREHOUSE := CONCAT('LABCAMP_WH_', LPAD(TO_VARCHAR(CEIL(COUNTER/5)), 2, '0'));

    CREATE OR REPLACE USER identifier(:USER_NAME)
    PASSWORD = :USER_NAME
    LOGIN_NAME = :USER_NAME,
    DEFAULT_WAREHOUSE = :USER_WAREHOUSE,
    DEFAULT_ROLE = LABCAMP_ROLE
    COMMENT = 'Reply Labcamp - Technical and Personal User.';
    
    GRANT ROLE LABCAMP_ROLE TO USER identifier(:USER_NAME);
    GRANT OWNERSHIP ON USER identifier(:USER_NAME) TO ROLE USERADMIN;
    
  END FOR;
  RETURN COUNTER;

END;
$$
;